Merge tag 'driver-core-4.17-rc1' of git://git.kernel.org/pub/scm/linux/kernel/git...
[linux-2.6-block.git] / scripts / package / Makefile
CommitLineData
1da177e4
LT
1# Makefile for the different targets used to generate full packages of a kernel
2# It uses the generic clean infrastructure of kbuild
3
1da177e4
LT
4# RPM target
5# ---------------------------------------------------------------------------
6# The rpm target generates two rpm files:
7# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
8# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
9# The src.rpm files includes all source for the kernel being built
10# The <arch>.rpm includes kernel configuration, modules etc.
11#
12# Process to create the rpm files
13# a) clean the kernel
14# b) Generate .spec file
15# c) Build a tar ball, using symlink to make kernel version
16# first entry in the path
17# d) and pack the result to a tar.gz file
18# e) generate the rpm files, based on kernel.spec
19# - Use /. to avoid tar packing just the symlink
20
db9038c8
FP
21# Note that the rpm-pkg target cannot be used with KBUILD_OUTPUT,
22# but the binrpm-pkg target can; for some reason O= gets ignored.
23
1da177e4 24# Remove hyphens since they have special meaning in RPM filenames
e1287eb8 25KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
3716001b
RV
26KDEB_SOURCENAME ?= linux-$(KERNELRELEASE)
27export KDEB_SOURCENAME
6615d6c3 28# Include only those top-level files that are needed by make, plus the GPL copy
26803821 29TAR_CONTENT := $(KBUILD_ALLDIRS) .config .scmversion Makefile \
6615d6c3 30 Kbuild Kconfig COPYING $(wildcard localversion*)
1da177e4 31MKSPEC := $(srctree)/scripts/package/mkspec
1da177e4 32
26803821
RV
33quiet_cmd_src_tar = TAR $(2).tar.gz
34 cmd_src_tar = \
262dad68 35set -e; \
26803821 36if test "$(objtree)" != "$(srctree)"; then \
262dad68
MY
37 echo >&2; \
38 echo >&2 " ERROR:"; \
39 echo >&2 " Building source tarball is not possible outside the"; \
40 echo >&2 " kernel source tree. Don't set KBUILD_OUTPUT, or use the"; \
41 echo >&2 " binrpm-pkg or bindeb-pkg target instead."; \
42 echo >&2; \
26803821
RV
43 false; \
44fi ; \
45$(srctree)/scripts/setlocalversion --save-scmversion; \
26803821 46tar -cz $(RCS_TAR_IGNORE) -f $(2).tar.gz \
2dbc644a
MY
47 --transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3); \
48rm -f $(objtree)/.scmversion
26803821 49
1da177e4 50# rpm-pkg
0131705d 51# ---------------------------------------------------------------------------
ebaad7d3 52rpm-pkg: FORCE
1da177e4 53 $(MAKE) clean
65013203 54 $(CONFIG_SHELL) $(MKSPEC) >$(objtree)/kernel.spec
26803821 55 $(call cmd,src_tar,$(KERNELPATH),kernel.spec)
8a16a070
MY
56 +rpmbuild $(RPMOPTS) --target $(UTS_MACHINE) -ta $(KERNELPATH).tar.gz \
57 --define='_smp_mflags %{nil}'
1da177e4
LT
58
59# binrpm-pkg
0131705d 60# ---------------------------------------------------------------------------
65013203 61binrpm-pkg: FORCE
a91f98a2 62 $(MAKE) KBUILD_SRC=
65013203 63 $(CONFIG_SHELL) $(MKSPEC) prebuilt > $(objtree)/binkernel.spec
606625be 64 +rpmbuild $(RPMOPTS) --define "_builddir $(objtree)" --target \
f66ba560 65 $(UTS_MACHINE) -bb $(objtree)/binkernel.spec
af60e207
MY
66
67clean-files += $(objtree)/*.spec
1da177e4
LT
68
69# Deb target
70# ---------------------------------------------------------------------------
db1d1865
JN
71quiet_cmd_builddeb = BUILDDEB
72 cmd_builddeb = set -e; \
73 test `id -u` = 0 || \
74 test -n "$(KBUILD_PKG_ROOTCMD)" || { \
75 which fakeroot >/dev/null 2>&1 && \
76 KBUILD_PKG_ROOTCMD="fakeroot -u"; \
77 } || { \
78 echo; \
79 echo "builddeb must be run as root (or using fakeroot)."; \
80 echo "KBUILD_PKG_ROOTCMD is unset and fakeroot not found."; \
81 echo "Try setting KBUILD_PKG_ROOTCMD to a command to acquire"; \
82 echo "root privileges (e.g., 'fakeroot -u' or 'sudo')."; \
83 false; \
84 } && \
85 \
86 $$KBUILD_PKG_ROOTCMD $(CONFIG_SHELL) \
3716001b 87 $(srctree)/scripts/package/builddeb $@
db1d1865 88
0131705d 89deb-pkg: FORCE
3716001b
RV
90 $(MAKE) clean
91 $(call cmd,src_tar,$(KDEB_SOURCENAME))
92 $(MAKE) KBUILD_SRC=
93 +$(call cmd,builddeb)
94
95bindeb-pkg: FORCE
a91f98a2 96 $(MAKE) KBUILD_SRC=
3716001b 97 +$(call cmd,builddeb)
1da177e4
LT
98
99clean-dirs += $(objtree)/debian/
100
5704d455
PP
101# snap-pkg
102# ---------------------------------------------------------------------------
103snap-pkg: FORCE
104 rm -rf $(objtree)/snap
105 mkdir $(objtree)/snap
106 $(MAKE) clean
107 $(call cmd,src_tar,$(KERNELPATH))
108 sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
109 s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
110 $(srctree)/scripts/package/snapcraft.template > \
111 $(objtree)/snap/snapcraft.yaml
112 cd $(objtree)/snap && \
113 snapcraft --target-arch=$(UTS_MACHINE)
114
115clean-dirs += $(objtree)/snap/
1da177e4 116
6d983fea
JBG
117# tarball targets
118# ---------------------------------------------------------------------------
0131705d 119tar%pkg: FORCE
6073aa64 120 $(MAKE) KBUILD_SRC=
6d983fea
JBG
121 $(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@
122
123clean-dirs += $(objtree)/tar-install/
124
125
8e5564e6
ACM
126# perf-pkg - generate a source tarball with perf source
127# ---------------------------------------------------------------------------
128
129perf-tar=perf-$(KERNELVERSION)
130
131quiet_cmd_perf_tar = TAR
132 cmd_perf_tar = \
3bdccc88 133git --git-dir=$(srctree)/.git archive --prefix=$(perf-tar)/ \
134 HEAD^{tree} $$(cd $(srctree); \
4b63f603 135 echo $$(cat tools/perf/MANIFEST)) \
3bdccc88 136 -o $(perf-tar).tar; \
8e5564e6 137mkdir -p $(perf-tar); \
3bdccc88 138git --git-dir=$(srctree)/.git rev-parse HEAD > $(perf-tar)/HEAD; \
a614d01b 139(cd $(srctree)/tools/perf; \
4b63f603 140util/PERF-VERSION-GEN $(CURDIR)/$(perf-tar)/); \
a614d01b 141tar rf $(perf-tar).tar $(perf-tar)/HEAD $(perf-tar)/PERF-VERSION-FILE; \
8e5564e6
ACM
142rm -r $(perf-tar); \
143$(if $(findstring tar-src,$@),, \
144$(if $(findstring bz2,$@),bzip2, \
145$(if $(findstring gz,$@),gzip, \
9a17f400
ZK
146$(if $(findstring xz,$@),xz, \
147$(error unknown target $@)))) \
8e5564e6
ACM
148 -f -9 $(perf-tar).tar)
149
150perf-%pkg: FORCE
151 $(call cmd,perf_tar)
152
1da177e4
LT
153# Help text displayed when executing 'make help'
154# ---------------------------------------------------------------------------
0131705d 155help: FORCE
8e5564e6 156 @echo ' rpm-pkg - Build both source and binary RPM kernel packages'
3716001b
RV
157 @echo ' binrpm-pkg - Build only the binary kernel RPM package'
158 @echo ' deb-pkg - Build both source and binary deb kernel packages'
159 @echo ' bindeb-pkg - Build only the binary kernel deb package'
5704d455 160 @echo ' snap-pkg - Build only the binary kernel snap package (will connect to external hosts)'
8e5564e6
ACM
161 @echo ' tar-pkg - Build the kernel as an uncompressed tarball'
162 @echo ' targz-pkg - Build the kernel as a gzip compressed tarball'
163 @echo ' tarbz2-pkg - Build the kernel as a bzip2 compressed tarball'
9a17f400 164 @echo ' tarxz-pkg - Build the kernel as a xz compressed tarball'
8e5564e6
ACM
165 @echo ' perf-tar-src-pkg - Build $(perf-tar).tar source tarball'
166 @echo ' perf-targz-src-pkg - Build $(perf-tar).tar.gz source tarball'
167 @echo ' perf-tarbz2-src-pkg - Build $(perf-tar).tar.bz2 source tarball'
9a17f400 168 @echo ' perf-tarxz-src-pkg - Build $(perf-tar).tar.xz source tarball'